> For the complete documentation index, see [llms.txt](https://docs.payments.thalescloud.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.payments.thalescloud.io/tokenization/implement-tokenization/card-tokenization-request/processing-the-decision/decision-engine/data-validation-codes.md).

# Data validation codes

Data validation codes help the Issuer analyze how D1 evaluates a Tokenization request.

D1 generates these codes when it validates data received from the payment network TSP and from the Issuer.

### Code groups

D1 returns two code groups:

* **Wallet reason codes** describe the recommendation context provided by the token requestor or wallet provider. D1 normalizes these values across payment network TSPs and wallet providers.
* **Verification codes** describe the checks performed by D1 on the data provided by the token requestor, payment network TSP, and Issuer.

### Where to access the codes

You can access these codes in the following D1 APIs:

* `Notify Card Operations` in the outbound [Card API](/tokenization/integrate-the-d1-api/d1-api-reference/outbound-api-from-d1/card-api.md)
* `Get operation` in the inbound [Card API](/tokenization/integrate-the-d1-api/d1-api-reference/inbound-api-to-d1/card-api.md)

### DIGITIZE response fields

For a `DIGITIZE` operation, the codes are returned in the `details` section:

* `digitizationInformation.digitizationChecks`
  * `.verificationCodes`
* `digitizationInformation.digitizationChecks`
  * `.digitalCardRequestorAssessment.reasonCodesRecommendationDescription`

### Code lists

Use the following pages for the full code lists:

* [Wallet reason codes](/tokenization/implement-tokenization/card-tokenization-request/processing-the-decision/decision-engine/data-validation-codes/wallet-reason-codes.md)
* [Verification codes](/tokenization/implement-tokenization/card-tokenization-request/processing-the-decision/decision-engine/data-validation-codes/verification-codes.md)

{% hint style="warning" %}
D1 can add, change, or remove these codes at any time based on updates from token requestors and payment network TSPs.

Do not hard-code these values in your system.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.payments.thalescloud.io/tokenization/implement-tokenization/card-tokenization-request/processing-the-decision/decision-engine/data-validation-codes.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
